﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;

namespace _314398_TreeViewExample
{
	public class ViewModel : ViewModelBase
	{
		public ViewModel()
		{
			ItemExpandedCommand = new DelegateCommand((a) => { this.LoadOnDemandCommand(a.ToString()); }, (p) => { return true; });

			Items = new ObservableCollection<DataItem>();

			for (int i = 0; i < 8; i++)
			{
				DataItem item = new DataItem()
				{
					Header = String.Format("Item {0}", i), IsLoadOnDemandEnabled = true
				};
				Items.Add(item);
			}

			this.SelectedItem = this.Items[0];
		}
		
		private DataItem selectedItem;
		public DataItem SelectedItem
		{
			get
			{
				return this.selectedItem;
			}
			set
			{
				if (this.selectedItem != value)
				{
					this.selectedItem = value;
					OnPropertyChanged("SelectedItem");
				}
			}
		}

		public DelegateCommand ItemExpandedCommand { get; set; }

		private void LoadOnDemandCommand(string param)
		{
			foreach (DataItem item in Items)
			{
				if (item.Header == param)
				{
					for (int i = 0; i < 5; i++)
					{
						item.Children.Add(new DataItem() { Header = String.Format("{0}.{1}", item.Header, i), IsLoadingOnDemand = false });
					}
					item.IsLoadingOnDemand = false;
				}
			}

		}

		public ObservableCollection<DataItem> Items { get; set; }
	}
}
